{% extends "users/userspace.html" %}

{% block content %}
<div class="container px-5 my-5">
        <h1>Outil d'exécution de scripts</h1>
        <div class="alert alert-danger">
            <b>ATTENTION:</b> Avant d'exécuter un script sur cette page, il est préférable de le tester sur une copie
            locale de la même version de Gaia (version du site: {{ version }}).
            <br>
            <br>
            <span class="fw-bold">N'utilisez pas cet outil si vous ne savez pas ce que vous faites. Les dommages peuvent être irréparables.</span>
        </div>
        <form method="post" action="" id="scripting-form" class="mb-3">
            {% csrf_token %}
            <label for="script-source-textarea" class="form-label">Insérez ici votre code :</label>
            <div class="border border-dark">
            <textarea name="script-source" id="script-source-textarea" class="form-control" rows="15">{{ script_source|safe }}</textarea>
            </div>
            <div class="row mt-1">
                <div class="col text-end">
                <button type="button" class="mt-2 btn btn-warning" data-bs-toggle="modal" data-bs-target="#confirm-modal">
                    Envoyer
                </button>
                </div>
            </div>
        </form>
        <label for="script-result" class="form-label">Résultat du script :</label>
        <textarea id="script-result" class="form-control mb-5" rows="20" disabled>{{ script_result }}</textarea>
    </div>

    <div class="modal fade" id="confirm-modal" data-bs-backdrop="static" data-bs-keyboard="false" tabindex="-1"
         aria-labelledby="confirm-modal-label" aria-hidden="true">
        <div class="modal-dialog modal-dialog-centered">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="confirm-modal-label">Confirmez l'opération</h5>
                    <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Annuler"></button>
                </div>
                <div class="modal-body">
                    <p>Vous allez réaliser une opération critique. Pour confirmer l'action, entrez le texte "Gaia {{ version }}" dans la barre ci-dessous :</p>
                    <input type="text" class="form-control" id="modal-input" />
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Annuler</button>
                    <button type="button" class="btn btn-danger" onclick="modalConfirm()">Valider</button>
                </div>
            </div>
        </div>
    </div>
{% endblock %}

{% block scripts %}
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.63.1/codemirror.min.css">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.63.1/codemirror.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.63.1/mode/python/python.min.js"></script>
    <script>
        var editor = CodeMirror.fromTextArea(document.getElementById("script-source-textarea"), {
        mode: "python",
        lineNumbers: true
        });
    </script>
    <script>
        function modalConfirm() {
            let modalInput = $("#modal-input").val();
            if(modalInput === "Gaia {{ version }}") {
                $("#scripting-form").submit();
            }
        }
    </script>
{% endblock %}
